diff -pruN 4.15-2/Changes 4.16-1/Changes
--- 4.15-2/Changes	2020-05-18 07:22:32.000000000 +0000
+++ 4.16-1/Changes	2020-06-20 09:33:19.000000000 +0000
@@ -1,5 +1,9 @@
 Revision history for {{$dist->name}}
 
+4.16 2020-06-20 Duncan Ferguson <duncan_ferguson@user.sf.net>
+- Further fix for 'resolve_names' error when adding hosts via the UI
+- Fix missing space separator for ssh_args (thanks to Petr Vorel)
+
 4.15 2020-05-18 Duncan Ferguson <duncan_ferguson@user.sf.net>
 - Include all utilies within each man page
 - Add in 'command_pre' and 'command_post' configuration options
diff -pruN 4.15-2/debian/changelog 4.16-1/debian/changelog
--- 4.15-2/debian/changelog	2020-05-25 13:40:59.000000000 +0000
+++ 4.16-1/debian/changelog	2020-06-23 18:43:49.000000000 +0000
@@ -1,3 +1,10 @@
+clusterssh (4.16-1) unstable; urgency=medium
+
+  * New upstream version 4.16
+  * Remove fix_ssh_args patch applied upstream
+
+ -- tony mancill <tmancill@debian.org>  Tue, 23 Jun 2020 11:43:49 -0700
+
 clusterssh (4.15-2) unstable; urgency=medium
 
   * Add patch to fix regression with ssh_args (#961475)
diff -pruN 4.15-2/debian/patches/fix_ssh_args.patch 4.16-1/debian/patches/fix_ssh_args.patch
--- 4.15-2/debian/patches/fix_ssh_args.patch	2020-05-25 13:40:59.000000000 +0000
+++ 4.16-1/debian/patches/fix_ssh_args.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-Description: fix broken ssh_args command in upstream version 4.15
-Debian-Bug: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=961475
-Author: Samuel Thibault <sthibault@debian.org>
-
---- a/lib/App/ClusterSSH/Helper.pm
-+++ b/lib/App/ClusterSSH/Helper.pm
-@@ -71,7 +71,7 @@
-            my \$user=shift;
-            my \$port=shift;
-            my \$mstr=shift;
--           my \$command="$command_pre $comms $comms_args";
-+           my \$command="$command_pre $comms $comms_args ";
-            open(PIPE, ">", \$pipe) or die("Failed to open pipe: \$!\\n");
-            print PIPE "\$\$:\$ENV{WINDOWID}" 
-                or die("Failed to write to pipe: $!\\n");
diff -pruN 4.15-2/debian/patches/series 4.16-1/debian/patches/series
--- 4.15-2/debian/patches/series	2020-05-25 13:40:59.000000000 +0000
+++ 4.16-1/debian/patches/series	2020-06-23 18:43:49.000000000 +0000
@@ -2,4 +2,3 @@
 range_whatis_entry.patch
 perl_shebang.patch
 manpage_typo.patch
-fix_ssh_args.patch
diff -pruN 4.15-2/lib/App/ClusterSSH/Helper.pm 4.16-1/lib/App/ClusterSSH/Helper.pm
--- 4.15-2/lib/App/ClusterSSH/Helper.pm	2020-05-18 07:22:32.000000000 +0000
+++ 4.16-1/lib/App/ClusterSSH/Helper.pm	2020-06-20 09:33:19.000000000 +0000
@@ -71,9 +71,9 @@ sub script {
            my \$user=shift;
            my \$port=shift;
            my \$mstr=shift;
-           my \$command="$command_pre $comms $comms_args";
+           my \$command="$command_pre $comms $comms_args ";
            open(PIPE, ">", \$pipe) or die("Failed to open pipe: \$!\\n");
-           print PIPE "\$\$:\$ENV{WINDOWID}" 
+           print PIPE "\$\$:\$ENV{WINDOWID}"
                or die("Failed to write to pipe: $!\\n");
            close(PIPE) or die("Failed to close pipe: $!\\n");
            if(\$svr =~ m/==\$/)
diff -pruN 4.15-2/lib/App/ClusterSSH/Window/Tk.pm 4.16-1/lib/App/ClusterSSH/Window/Tk.pm
--- 4.15-2/lib/App/ClusterSSH/Window/Tk.pm	2020-05-18 07:22:32.000000000 +0000
+++ 4.16-1/lib/App/ClusterSSH/Window/Tk.pm	2020-06-20 09:33:19.000000000 +0000
@@ -356,7 +356,7 @@ sub add_host_by_name() {
     if ( defined $menus{listbox} && $menus{listbox}->curselection() ) {
         my @hosts = $menus{listbox}->get( $menus{listbox}->curselection() );
         $self->debug( 2, "host=", join( ' ', @hosts ) );
-        $self->open_client_windows( $self->resolve_names(@hosts) );
+        $self->open_client_windows( $self->parent->resolve_names(@hosts) );
     }
 
     $self->build_hosts_menu();
@@ -1204,7 +1204,7 @@ sub setup_repeat() {
 
                         for ($cmd) {
                             if (m/^open$/) {
-                                my @new_hosts = $self->resolve_names(@tags);
+                                my @new_hosts = $self->parent->resolve_names(@tags);
                                 $self->open_client_windows(@new_hosts);
                                 $self->build_hosts_menu();
                                 last;
diff -pruN 4.15-2/lib/App/ClusterSSH.pm 4.16-1/lib/App/ClusterSSH.pm
--- 4.15-2/lib/App/ClusterSSH.pm	2020-05-18 07:22:32.000000000 +0000
+++ 4.16-1/lib/App/ClusterSSH.pm	2020-06-20 09:33:19.000000000 +0000
@@ -5,7 +5,7 @@ package App::ClusterSSH;
 # ABSTRACT: Cluster administration tool
 # ABSTRACT: Cluster administration tool
 
-use version; our $VERSION = version->new('4.15');
+use version; our $VERSION = version->new('4.16');
 
 =head1 SYNOPSIS
 
diff -pruN 4.15-2/README 4.16-1/README
--- 4.15-2/README	2020-05-18 07:22:32.000000000 +0000
+++ 4.16-1/README	2020-06-20 09:33:19.000000000 +0000
@@ -2,7 +2,7 @@ NAME
     cssh - Cluster administration tool
 
 VERSION
-    This documentation is for version: 4.15
+    This documentation is for version: 4.16
 
 SYNOPSIS
     cssh [-a '<command>'] [-K <seconds>] [-q] [-c '<filename>'] [-x <cols>]
diff -pruN 4.15-2/THANKS 4.16-1/THANKS
--- 4.15-2/THANKS	2020-05-18 07:22:32.000000000 +0000
+++ 4.16-1/THANKS	2020-06-20 09:33:19.000000000 +0000
@@ -48,3 +48,4 @@ Bill Rushmore
 Ankit Vadehra
 Azenet
 Markus Frosch (lazyfrosch)
+Petr Vorel
